searchNodes=[{"doc":"Demuxes MPEG TS stream.After transition into playing state, this element will wait for Program Association Table and Program Mapping Table. Upon succesfful parsing of those tables it will send a message to the pipeline in format {:mpeg_ts_stream_info, configuration}, where configuration contains data read from tables.Configuration sent by element to pipeline should have following shape%{ program_id =&gt; %Membrane.MPEG.TS.ProgramMapTable{ pcr_pid: 256, program_info: [], streams: %{ 256 =&gt; %{stream_type: :H264, stream_type_id: 27}, 257 =&gt; %{stream_type: :MPEG1_AUDIO, stream_type_id: 3} } } }Pads:inputAvailability:alwaysBin?falseCaps:anyDemand&amp;nbsp;unit:buffersDirection:inputMode:pullName:input:outputAvailability:on_requestBin?falseCaps:anyDirection:outputMode:pullName:output","ref":"Membrane.MPEG.TS.Demuxer.html","title":"Membrane.MPEG.TS.Demuxer","type":"module"},{"doc":"Returns pads descriptions for Membrane.MPEG.TS.Demuxer","ref":"Membrane.MPEG.TS.Demuxer.html#membrane_pads/0","title":"Membrane.MPEG.TS.Demuxer.membrane_pads/0","type":"function"},{"doc":"This types represents datae structure that is sent by this element to pipeline.","ref":"Membrane.MPEG.TS.Demuxer.html#t:configuration/0","title":"Membrane.MPEG.TS.Demuxer.configuration/0","type":"type"},{"doc":"Membrane Multimedia Framework: MPEG-TSThis package provides an element that can be used for demuxing MPEG-TS.It is part of Membrane Multimedia Framework.","ref":"readme.html","title":"Membrane Multimedia Framework: MPEG-TS","type":"extras"},{"doc":"The package can be installed by adding membrane_mpegts_plugin to your list of dependencies in mix.exs:def deps do [ {:membrane_mpegts_plugin, &quot;~&gt; 0.1.0&quot;} ] endThe docs can be found at HexDocs.","ref":"readme.html#installation","title":"Membrane Multimedia Framework: MPEG-TS - Installation","type":"extras"},{"doc":"PAT - Program Association Table PMT - Program Mapping Table","ref":"readme.html#abbreviations","title":"Membrane Multimedia Framework: MPEG-TS - Abbreviations","type":"extras"},{"doc":"Demuxer is an element that has one :input and variable amount of outputs depending on the stream. In this particular example we are demuxing a file that contains MPEG1 audio and H264 video.@impl true def handle_init(path) do children = [ source_file: %File.Source{location: path, chunk_size: 64_000}, demuxer: MPEG.TS.Demuxer, video_parser: %H264.Parser{framerate: {24, 1}}, video_decoder: H264.Decoder, player: SDL.Player, audio_decoder: Mad.Decoder, audio_converter: %SWResample.Converter{ output_caps: %Raw{channels: 2, format: :s16le, sample_rate: 48_000} }, portaudio: PortAudio.Sink ] links = [ link(:source_file) |&gt; to(:demuxer), link(:demuxer) |&gt; via_out(Pad.ref(:output, 256)) |&gt; to(:video_parser), link(:demuxer) |&gt; via_out(Pad.ref(:output, 257)) |&gt; to(:audio_decoder), link(:video_parser) |&gt; to(:video_decoder), link(:video_decoder) |&gt; to(:player), link(:audio_decoder) |&gt; to(:audio_converter), link(:audio_converter) |&gt; to(:portaudio) ] spec = %Spec{ children: children, links: links, stream_sync: :sinks } {{:ok, spec: spec}, %{}} endUpon successful parsing of MPEG Transport stream specific information, demuxer will notify its parent (usally a pipeline). When the parent receives {:mpeg_ts_stream_info, prog_map_tables} message it will need to link the demuxer outputs. The demuxer will continue its work when either every stream will have its corresponding pad linked or after receiving :pads_ready message. If demuxer receives :pads_ready it will continue its work even though some pads might not be linked.prog_map_tables that is received by pipeline has following format:%{ program_id =&gt; %Membrane.MPEG.TS.ProgramMapTable{ streams: %{ packet_identifier =&gt; %{ type: atom, type_id: 0..255 } } } }So, far example, if we wanted to have as simple behaviour as use first stream with matching type we would do it like this:@impl true def handle_notification({:mpeg_ts_stream_info, pmt}, _from, state) do {audio_pid, video_pid} = parse_mapping(pmt) children = [ audio: An.Audio.Element, video: A.Video.Element ] links = [ link(:demuxer) |&gt; via_out(Pad.ref(:output, audio_pid)) |&gt; to(:audio), link(:demuxer) |&gt; via_out(Pad.ref(:output, video_pid)) |&gt; to(:video) ] spec = %Spec{ children: children, links: links, } {{:ok, spec: spec}, state} end defp parse_mapping(mapping) do mapping = mapping[1] with {:ok, audio_pid} &lt;- first_matching_stream(mapping.streams, :MPEG1_AUDIO), {:ok, video_pid} &lt;- first_matching_stream(mapping.streams, :H264) do {audio_pid, video_pid} end end def first_matching_stream(streams, type) do streams |&gt; Enum.find(fn {_, value} -&gt; value.type == type end) |&gt; case do nil -&gt; {:error, :no_stream} {pid, _stream_spec} -&gt; {:ok, pid} end end","ref":"readme.html#usage","title":"Membrane Multimedia Framework: MPEG-TS - Usage","type":"extras"},{"doc":"Copyright 2019, Software MansionLicensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane Multimedia Framework: MPEG-TS - Copyright and License","type":"extras"}]